Imports System.Threading
Imports System.Net.Sockets
Imports System.IO

Public Class ClientClass
    Const port As Integer = 8001
    Private output As NetworkStream
    Private writer As BinaryWriter
    Private reader As BinaryReader
    Private message As String = ""
    Private readThread As Thread
    Private ClientConnection As Boolean = False
    Private client As TcpClient
    Private started As Boolean = False

    Public ReadOnly Property ClientConnected() As Boolean
        Get
            Return ClientConnection
        End Get
    End Property

    Public Sub DisconnectClient()
        If ClientConnection = True Then
            reader.Close()
            writer.Close()
            ClientConnection = False
        End If
        If started = True Then
            readThread.Abort()
            client.Close()
        End If
    End Sub

    Public Sub StartComms()
        readThread = New Thread(AddressOf RunClient)
        readThread.Name = "Client Reading Thread"
        readThread.Start()
        started = True
    End Sub

    Public Sub SendMessage(ByVal Message As String)
        Try
            writer.Write(Message)
            Console.WriteLine(Now.ToLongTimeString & " TX: " & Message)
        Catch exception As SocketException
            MessageBox.Show("Unable to Transmit to MRCCC Server", mrcc)
            GUI.Disconnect()
        End Try
    End Sub

    Public Sub RunClient()
        Try
            client = New TcpClient
            client.Connect(System.Net.IPAddress.Parse(GUI.ServerIP), port)
        Catch
            MessageBox.Show("Unable to Establish Connection to Server", mrcc)
            'Shut resources being used
            client.Close()
            GUI.ServerIP = ""
            Exit Sub 'Quit
        End Try
        output = client.GetStream()
        writer = New BinaryWriter(output)
        reader = New BinaryReader(output)
        ClientConnection = True

        Try
            Do
                message = reader.ReadString
                Console.WriteLine(Now.ToLongTimeString & " RX: " & message)
                If message <> "" Then GUI.OnIncomingMessage(message)
            Loop
        Catch
            If ClientConnection = True Then MessageBox.Show("Unable to Read from Server", mrcc)
        End Try
        ClientConnection = False
        GUI.Disconnect()
    End Sub
End Class
