Imports System.Threading
Imports System.Net
Imports System.IO

Public Class ServerClass
    'Iniatialising Server
    '********************
    Public Listener As Sockets.TcpListener
    Private started As Boolean = False
    Private Lipthread As Threading.Thread
    Private NetPresent As Boolean = False
    Private LIP As String = "127.0.0.1"
    Private WithEvents Timer As New Timers.Timer(100)
    Public Function LocalIP() As String
        Return LIP
    End Function
    Public Function isRunning() As Boolean
        Return Me.started
    End Function
    Public Sub New(ByVal port As Integer)
        InitServer(port)
    End Sub
    Private Sub InitServer(ByVal Port As Integer)
        GetLocalIP()
        If Me.NetPresent Then
            Listener = New Sockets.TcpListener(IPAddress.Parse(LIP), Port)
        Else
            MessageBox.Show("Network Unavailable or blocked." & vbCrLf & "Ensure your Network is connected and Firewall set to enable MRCCC to communicate on Port " & Port & vbCr & vbCr & "MRCCC will try again once you acknowledge this box." & vbCrLf & "If Network remains unavailable, MultiUser will not be available - restart MRCCC to try again", mrcc)
            Listener = New Sockets.TcpListener(IPAddress.Parse(LIP), Port)
        End If
    End Sub
    Private Sub GetLocalIP()
        Lipthread = New Threading.Thread(AddressOf LocalIPThreadSub)
        Lipthread.Name = "GetLocalIP Thread"
        Lipthread.Priority = Threading.ThreadPriority.Highest
        Lipthread.Start()
        System.Threading.Thread.CurrentThread.Sleep(1200)
        Lipthread.Abort()
    End Sub
    Public Sub StartServer()
        If Not started Then
            Listener.Start()
            Timer.Start()
            Timer.Enabled = True
            started = True
        End If
    End Sub
    Private Sub LocalIPThreadSub()
        Try
            Dim Dns As System.Net.Dns
            LIP = Dns.Resolve(System.Net.Dns.GetHostName).AddressList(0).ToString()
            NetPresent = True
        Catch ex As Exception

        End Try
    End Sub

    Public Sub StopServer()
        If started Then
            Timer.Enabled = False
            Timer.Stop()
            Listener.Stop()
            started = False
        End If
    End Sub

    'Accepting New Conncection
    '*************************
    Private Sub AcceptClients(ByVal o As Object, ByVal e As System.Timers.ElapsedEventArgs) Handles Timer.Elapsed
        If Listener.Pending Then
            Timer.Enabled = False
            Dim NewCon As ClientConnection = New ClientConnection()
            Dim Thread As New Threading.Thread(AddressOf NewCon.NewConnection)
            If GUI.AddConnection(NewCon.IP, NewCon) Then
                Thread.Name = "Connection to " & NewCon.IP
                Thread.Start()
            End If
            Timer.Enabled = True
        End If
    End Sub

End Class

Public Class ClientConnection
    Public Event IncomingMessage(ByVal eventargs As InMessEvArgs)
    Dim connection As Sockets.Socket = GUI.Srv.Listener.AcceptSocket
    Private serverIP As String
    Private UserID As String = ""
    Private socketstream As Sockets.NetworkStream
    Dim REP As System.Net.IPEndPoint = connection.RemoteEndPoint
    Dim ClientIP As String = REP.Address.ToString
    Dim theReply As String = ""
    Dim WriteInUse As Boolean = False
    Private writer As BinaryWriter
    Private reader As BinaryReader

    Public ReadOnly Property IP() As String
        Get
            Return ClientIP
        End Get
    End Property

    Public ReadOnly Property ConnectionOK() As Boolean
        Get
            Return connection.Connected
        End Get
    End Property

    Sub New()
        socketstream = New Sockets.NetworkStream(connection)
        writer = New BinaryWriter(socketstream)
        reader = New BinaryReader(socketstream)
    End Sub

    Sub NewConnection()
        Dim counter As Integer = 0
        Try
            Do
                theReply = reader.ReadString()
                If theReply <> "" Then Console.WriteLine(Now().ToLongTimeString() & " " & IP & " > Server : " & theReply)
                counter += 1
            Loop Until theReply.StartsWith("*NEW*") Or counter = 3

            If counter <> 3 Then
                Dim id As String = GUI.CreateUser(Mid(theReply, 6), IP)
                If id <> "" Then
                    UserID = id
                    GUI.GetUser(UserID).AssignConnection(IP)
                    Send("*CON*" & id)
                    Run()
                Else

                End If
            End If
        Catch
            
        End Try
        GUI.DisconnectUser(UserID, IP)
    End Sub

    Public Sub Run()
        Try
            'Loop until connection terminated with Client
            Do
                If ModeChangeFlag = False Then theReply = reader.ReadString()

                If theReply <> "" Then
                    Console.WriteLine(Now().ToLongTimeString() & " " & UserID & " > Server : " & theReply)
                    Dim args As New InMessEvArgs(theReply, ClientIP)
                    GUI.GetUser(UserID).OnIncomingMessage(args)
                End If
            Loop
        Catch inputoutputexception As IOException
        End Try

    End Sub

    Public Sub Send(ByVal message As String)
        While WriteInUse = True
            'loop
        End While
        WriteInUse = True
        writer.Flush()
        If connection.Connected Then
            Try
                writer.Write(message)
            Catch
                GUI.DisconnectUser(UserID, True)
            End Try
        End If
        Console.WriteLine(Now().ToLongTimeString() & " " & "Server>" & UserID & " : " & message)
        WriteInUse = False
    End Sub

    Public Sub Disconnect()
        writer.Close()
        reader.Close()
        socketstream.Close()
        connection.Close()
    End Sub

    Public Structure InMessEvArgs
        Dim message As String
        Dim senderIP As String
        Public Sub New(ByVal Message As String, ByVal SenderIP As String)
            Me.message = Message
            Me.senderIP = SenderIP
        End Sub
    End Structure

End Class