Imports System.Threading
Imports System.Net
Imports System.Net.Sockets
Imports System.Text
Imports System.IO
Imports System.Configuration

Public Class User
    Dim username As String = ""
    Dim Connected As Boolean = False
    Dim Connection As ClientConnection

    Public Sub New(ByVal name As String)
        username = name
    End Sub
    ' Class provided for each User of the system for each session.

    Public ReadOnly Property Name() As String
        Get
            Return username
        End Get
    End Property

    Public ReadOnly Property IP() As String
        Get
            If username = "MRCCC Server" Or username = "MRCCC Remote Request" Then
                Return Dns.Resolve(System.Net.Dns.GetHostName).AddressList(0).ToString()
            Else
                If Connected Then
                    Return Connection.IP
                Else
                    Return "N/A"
                End If
            End If
        End Get
    End Property

    Public ReadOnly Property ClientConnected()
        Get
            Return Connected
        End Get
    End Property

    'Temp Route Setting Variable
    Private EntrySignalClicked As String = ""

    'Feedback String
    Private FeedbackText As String = ""


    '*******************************
    'COMMUNICATIONS
    '*******************************
    Public Sub AssignConnection(ByVal IP As String)
        Connection = GUI.GetConnection(IP)
        Connected = True
    End Sub

    Public Sub SendMessage(ByVal message As String)
        Connection.Send(message)
    End Sub

    Public Sub OnIncomingMessage(ByVal Args As ClientConnection.InMessEvArgs)

        'Retrieve received message:
        Dim M As String = Args.message
        'Retrieve sender IP
        Dim sIP As String = Args.senderIP

        If Mode > 0 Then
            Dim Command As String = Mid(M, 1, 5)
            Select Case Command
                Case "*QST*"
                    'Remote Mouse Click
                    GUI.RemoteRequest(username, Mid(M, 6))
                Case "*ALL*"
                    'Request for All sysmbols to be sent
                    GUI.SendWholeScreen(username)
            End Select
        End If
    End Sub


    '*******************************
    'USER ACTIONS
    '*******************************
    '
    ' Mouse Down
    ' **********
    '
    Public Function MouseClick(ByVal Request As UserRequest)
        FeedbackText = ""
        If ModeChangeFlag = False Then
            Select Case (Request.pLorR)
                Case "L"
                    'Left Button Events
                    'Decide Device Type Clicked On
                    Select Case (Data.GetDeviceType(Request.pX, Request.pY))
                        Case 0 To 8 'Signal
                            If EntrySignalClicked = "" Then
                                EntrySignalClicked = Data.GetByXY(Request.pX, Request.pY)
                            Else
                                'Attempt Route Set
                                Dim Route As String = MakeNX(EntrySignalClicked, Data.GetByXY(Request.pX, Request.pY))
                                If Data.RoutesIndex.ContainsKey(Route) Then
                                    RequestRoute(Route)
                                Else
                                    'Route Doesn't Exist
                                    FeedbackText = "No Route " & EntrySignalClicked & " to " & Data.GetByXY(Request.pX, Request.pY)
                                End If
                                EntrySignalClicked = ""
                            End If

                        Case 10 'Point
                            EntrySignalClicked = ""
                            Dim PointID As String = Data.GetByXY(Request.pX, Request.pY)
                            RequestKeyL(PointID)

                        Case 11 'Tk Section
                            EntrySignalClicked = ""
                            If Mode = 1 Then
                                Dim DevID As String = Data.GetByXY(Request.pX, Request.pY)
                                SimulateTCOcc(DevID)
                            End If
                        Case 12 'MiscIP
                            EntrySignalClicked = ""
                            Dim StMiscID As String = Data.GetByXY(Request.pX, Request.pY)
                            RequestSetMisc(stmiscid)

                        Case 14 'MiscOP
                            EntrySignalClicked = ""
                            'Do Nothing - No Actions
                        Case Else
                            EntrySignalClicked = ""
                    End Select
                Case "R"
                    'Right Button Events
                    'Decide Device Type Clicked On
                    Select Case (Data.GetDeviceType(Request.pX, Request.pY))
                        Case 0 To 8 'Signal
                            RequestRouteCancel(Request.pX, Request.pY)

                        Case 10 'Points
                            EntrySignalClicked = ""
                            Dim PointsID As String = Data.GetByXY(Request.pX, Request.pY)
                            RequestKeyR(PointsID)

                        Case 11 'Tk Section
                            EntrySignalClicked = ""
                            If Mode = 1 Then
                                Dim ID As String = Data.GetByXY(Request.pX, Request.pY)
                                SimulateTCClr(ID)
                            End If

                        Case 12 'MiscIP
                            EntrySignalClicked = ""
                            Dim StMiscID As String = Data.GetByXY(Request.pX, Request.pY)
                            RequestCancelMisc(StMiscID)

                        Case 14 'MiscOP
                            EntrySignalClicked = ""
                            'Do Nothing - No Actions
                        Case Else
                            EntrySignalClicked = ""
                    End Select
            End Select

        End If

        'Return Error Dialog to user
        If FeedbackText <> "" And Request.pUser <> "MRCCC Remote Request" Then GUI.FeedbackReport(FeedbackText, Request.pUser)
    End Function

    '*******************************
    'USER REQUESTS
    '*******************************

    Private Sub RequestRoute(ByVal ID As String)
        'Route Exists - Check Route is Not Set
        Dim RouteID = Data.RoutesIndex(ID)
        If CType(Data.Routes(RouteID), Route).USet Then
            'Route Already Set
            FeedbackText = "Route " & RouteID & " is already Set!"
        Else
            'Call Route
            FeedbackText = CType(Data.Routes(RouteID), Route).CallRoute()
        End If
    End Sub

    Private Sub RequestRouteCancel(ByVal x As Integer, ByVal y As Integer)
        Dim i As Integer
        For i = 0 To Data.Routes.Count - 1
            If CType(Data.Routes.GetByIndex(i), Route).EntrySig = Data.GetByXY(x, y) Then
                If CType(Data.Routes.GetByIndex(i), Route).USet = True Then CType(Data.Routes.GetByIndex(i), Route).CancelRoute()
            End If
        Next
    End Sub

    Private Sub RequestKeyL(ByVal ID As String)
        If Data.GetPoint(ID).Key = "C" Then
            FeedbackText = Data.GetPoint(ID).KeyNormal()
        Else
            If Data.GetPoint(ID).Key = "N" Then Data.GetPoint(ID).KeyCentre()
        End If
    End Sub

    Private Sub RequestKeyR(ByVal ID As String)
        If Data.GetPoint(ID).Key = "C" Then
            FeedbackText = Data.GetPoint(ID).KeyReverse()
        Else
            If Data.GetPoint(ID).Key = "R" Then Data.GetPoint(ID).KeyCentre()
        End If
    End Sub

    Private Sub SimulateTCOcc(ByVal ID As String)
        If Data.GetTKSection(ID).TC = True Then
            'Simulate Input Bit
            HW.SimulateInput(Data.GetTKSection(ID).TCInputBit, False)
        End If
    End Sub

    Private Sub SimulateTCClr(ByVal ID As String)
        If Data.GetTKSection(ID).TC = True Then
            'Simulate Input Bit
            HW.SimulateInput(Data.GetTKSection(ID).TCInputBit, True)
        End If
    End Sub

    Private Sub RequestSetMisc(ByVal ID As String)
        FeedbackText = Data.GetStaticMisc(ID).SetMisc()
    End Sub

    Private Sub RequestCancelMisc(ByVal ID As String)
        Data.GetStaticMisc(ID).CancelMisc()
    End Sub
End Class

Public Class UserRequest
    Dim x As Integer = 0
    Dim y As Integer = 0
    Dim LorR As Char = "L"
    Dim userid As String = ""

    Public Sub New(ByVal Xpos As Integer, ByVal Ypos As Integer, ByVal LorRClick As Char, ByVal User As String)
        userid = User
        x = Xpos
        y = Ypos
        LorR = LorRClick
    End Sub

    Public ReadOnly Property pX() As Integer
        Get
            Return x
        End Get

    End Property

    Public ReadOnly Property pY() As Integer
        Get
            Return y
        End Get
    End Property

    Public ReadOnly Property pLorR() As Char
        Get
            Return LorR
        End Get
    End Property

    Public ReadOnly Property pUser() As String
        Get
            Return userid
        End Get
    End Property


End Class